define(function(require){
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");
	var biz = require("$UI/system/lib/biz");
	var clqdSrc = 1;//(1.从抢修内容页面点击【材料清单】  2.从任务详细页面点击【材料清单】)
	require("cordova!com.justep.cordova.plugin.push");
	
	//只有打开这个功能后, 这个alert才会生效
	biz.Push.on(biz.Push.MESSAGE_EVENT, function(event){
		var title = event.message.title || event.message.aps.alert || "";
		alert("接收到新消息：" + title);
	});
	
	var Model = function(){
		this.callParent();
	};
	
	//页面初始
	Model.prototype.modelLoad = function(event){
		//取得任务一览数据
		this.getTaskList();
	};
	
	//=======================任务一览页面 begin=============
	//取得任务一览数据（完工、撤销的数据不显示；对于手持设备来说，不存在“未落实”的任务）
	Model.prototype.getTaskList = function(){
		var dispData = this.comp('dispData');
		var params = new biz.Request.ActionParam();
		params.setString("pda_id", this.getContext().getCurrentPersonCode());
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "getTaskListAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					dispData.loadData(resultData.response);
				} else {
					throw new Error('取得任务一览数据失败！');
				}
			}
		});
		
		//取得统计数据
		this.getTaskStatic();
	};
	
	//取得统计数据
	Model.prototype.getTaskStatic = function(){
		var me = this;
		var rwStatisData = this.comp('rwStatisData');
		var params = new biz.Request.ActionParam();
		params.setString("pda_id", this.getContext().getCurrentPersonCode());
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "getTaskNumStatisPdaAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					rwStatisData.loadData(resultData.response);
					rwStatisData.refreshData();
					var titleStr = '　总：<font color=red>'
							+ (rwStatisData.val('zrws') === undefined ? '0' : rwStatisData.val('zrws')) + '</font>　派：<font color=blue>'
							+ (rwStatisData.val('ypg') === undefined ? '0' : rwStatisData.val('ypg')) + '</font>　执：<font color=brown>'
							+ (rwStatisData.val('zxz') === undefined ? '0' : rwStatisData.val('zxz')) + '</font>　完：<font color=green>'
							+ (rwStatisData.val('ywg') === undefined ? '0' : rwStatisData.val('ywg')) + '</font>　撤：<font color=purple>'
							+ (rwStatisData.val('ycx') === undefined ? '0' : rwStatisData.val('ycx')) + '</font>';
//					$(me.getElementsByXid('staticDiv')).html(titleStr);
				} else {
					throw new Error('取得任务一览数据失败！');
				}
			}
		});
	};  
	
	//【接报录入】
	Model.prototype.jblrBtnClick = function(event){
		var url = '$UI' + event.source.$domNode.attr('url')+'?process=/qx/pda/process/jblr/jblrProcess&activity=jblr';
		justep.Portal.openWindow(url);
	};
	//=======================任务一览页面 end=============  
	
	//=======================任务详情页面 begin=============   
    //点击list的一行数据
	Model.prototype.listRowClick = function(event){
		var row = event.bindingContext.$object;
		this.getTaskDetail({data:{disp_id:row.val('disp_id')}});
		this.comp('ddpgContents').to('detailCnt');
	};  
	//取得任务详细
	Model.prototype.getTaskDetail = function(event){
		var dispDetailData = this.comp('dispDetailData');
		var params = new biz.Request.ActionParam();
		params.setString("disp_id", event.data.disp_id);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "getTaskDetailAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					dispDetailData.loadData(resultData.response);
					dispDetailData.first();
				} else {
					throw new Error('取得任务详情失败！');
				}
			}
		});
	};
        
    //任务详细   【<】
	Model.prototype.detailBackBtnClick = function(event){
		this.comp('ddpgContents').to('listCnt');
		this.getTaskList();
	}; 
	//=======================任务详情页面 end============= 
	
	//=======================popup列表中按钮事件 begin=============  
	//【接受任务】
	Model.prototype.jsrwBtnClick = function(event){
		var saveFlg = 0;
		var params = new biz.Request.ActionParam();
		params.setInteger("disp_id", this.comp('dispDetailData').val('disp_id'));
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "taskNormalJsrwPdaAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					saveFlg = resultData.response;
				} else {
					throw new Error('提交失败！');
				}
			}
		});

		if (saveFlg === 0) {
			justep.Util.hint("提交成功！", {
				type : 'success',
				delay : 5000,
				parent : this.getRootNode()
			});
			
			this.getTaskDetail({data:{disp_id:this.comp('dispDetailData').val('disp_id')}});
		} else {
			justep.Util.hint("提交失败！", {
				type : 'warning',
				delay : 5000,
				parent : this.getRootNode()
			});
		}
	};
	//【已到达】
	Model.prototype.yddBtnClick = function(event){
		this.comp('yddskDialog').open();
	}; 
	Model.prototype.yddskDialogReceive = function(event){
		var chipNum = event.data.chipNum;//需要将对应的卡号等信息保存到db，尚未处理
		var saveStr = '';
		var params = new biz.Request.ActionParam();
		params.setInteger("disp_id", this.comp('dispDetailData').val('disp_id'));
		params.setString("pda_id", this.getContext().getCurrentPersonCode());
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "taskNormalDdPdaAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					saveStr = resultData.response;
				} else {
					throw new Error('提交失败！');
				}
			}
		});

		if (saveStr === '') {
			justep.Util.hint("提交成功！", {
				type : 'success',
				delay : 5000,
				parent : this.getRootNode()
			});
			
			this.getTaskDetail({data:{disp_id:this.comp('dispDetailData').val('disp_id')}});
		} else {
			justep.Util.hint(saveStr, {
				type : 'warning',
				delay : 5000,
				parent : this.getRootNode()
			});
		}
	}; 
	//【已清障】
	Model.prototype.yqzBtnClick = function(event){
		var saveFlg = 0;
		var params = new biz.Request.ActionParam();
		params.setInteger("disp_id", this.comp('dispDetailData').val('disp_id'));
		params.setString("pda_id", this.getContext().getCurrentPersonCode());
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "taskNormalQzPdaAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					saveFlg = resultData.response;
				} else {
					throw new Error('提交失败！');
				}
			}
		});

		if (saveFlg === 0) {
			justep.Util.hint("提交成功！", {
				type : 'success',
				delay : 5000,
				parent : this.getRootNode()
			});
			
			this.getTaskDetail({data:{disp_id:this.comp('dispDetailData').val('disp_id')}});
		} else {
			justep.Util.hint("提交失败！", {
				type : 'warning',
				delay : 5000,
				parent : this.getRootNode()
			});
		}
	}; 
	//【开始拖车】
	Model.prototype.kstcBtnClick = function(event){
		var saveFlg = 0;
		var params = new biz.Request.ActionParam();
		params.setInteger("disp_id", this.comp('dispDetailData').val('disp_id'));
		params.setString("pda_id", this.getContext().getCurrentPersonCode());
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "taskNormalTcPdaAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					saveFlg = resultData.response;
				} else {
					throw new Error('提交失败！');
				}
			}
		});

		if (saveFlg === 0) {
			justep.Util.hint("提交成功！", {
				type : 'success',
				delay : 5000,
				parent : this.getRootNode()
			});
			
			this.getTaskDetail({data:{disp_id:this.comp('dispDetailData').val('disp_id')}});
		} else {
			justep.Util.hint("提交失败！", {
				type : 'warning',
				delay : 5000,
				parent : this.getRootNode()
			});
		}
	}; 
	//【任务撤销】
	Model.prototype.rwcxBtnClick = function(event){
		if(this.getClqdStr() !==''){
			this.comp('msg').show({message : '已有材料消耗，不能撤销！'});
		}else{
			this.comp('rwcxDialog').open();
		}
	};  
	Model.prototype.rwcxDialogReceive = function(event){
		var saveFlg = 0;
		var params = new biz.Request.ActionParam();
		params.setInteger("task_id", this.comp('dispDetailData').val('task_id'));
		params.setString("pda_id", this.getContext().getCurrentPersonCode());
		params.setString("cxly", event.data.cxly);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "taskNormalCxPdaAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					saveFlg = resultData.response;
				} else {
					throw new Error('任务撤销失败！');
				}
			}
		});

		if (saveFlg === 0) {
			this.comp('msg').show({message : '任务撤销成功！'});
			
			this.getTaskList();
			this.comp('ddpgContents').to('listCnt');
		} else {
			this.comp('msg').show({message : '任务撤销失败！'});
		}
	};
	//=======================popup列表中按钮事件 end=============   
	
	//=======================完工处理 begin============= 
    //【完工处理】
	Model.prototype.wgclBtnClick = function(event){
		this.comp('ddpgContents').to('qxjgCnt');
		this.initWgInfo();
	};
	
	//初始完工信息（抢修结果、拖移地点）
	Model.prototype.initWgInfo = function(event){
		var pageData = this.comp('pageData');
		pageData.setValue('qxjg', '');
		pageData.setValue('tydd', '');
		pageData.setValue("qxnr", '');
		this.setQxnr();
		
		//抢修结果下拉框
		var qxjgData = this.comp('qxjgData');
		qxjgData.setFilter("cllxFil", "cllx = '"+ localStorage.getItem("syz_lx") + "'" );
		qxjgData.refreshData();
		
		//拖移地点下拉框
		this.comp('tyddData').refreshData();
	};
	
	//抢修结果
	Model.prototype.qxjgSelectChange = function(event){
		this.qxjgNextBtnClick();
	}; 
	//抢修结果,【下一步】
	Model.prototype.qxjgNextBtnClick = function(event){
		var qxjg = $(this.getElementsByXid('qxjgSelect')).val();
		if(qxjg === ''){
			this.comp('msg').show({message:'请选择抢修结果！'});
		}else{
			this.comp('pageData').setValue("tydd","");
			if(qxjg === '即修'){
				this.comp('ddpgContents').to('qxnrCnt');			
			}else{
				this.comp('ddpgContents').to('tcddCnt');
			}
		}
	};  
    //抢修结果   【<】 
	Model.prototype.qxjgBackBtnClick = function(event){
		this.comp('ddpgContents').to('detailCnt');
	};  
	
	//拖车、回厂目的地
	Model.prototype.tchcSelectChange = function(event){
		this.tcddNextBtnClick();
	};
	//拖车、回厂目的地,【下一步】
	Model.prototype.tcddNextBtnClick = function(event){
		var qxjg = $(this.getElementsByXid('qxjgSelect')).val();
		var tydd = $(this.getElementsByXid('tchcSelect')).val();
		if(qxjg !=='即修' && tydd === ''){
			this.comp('msg').show({message:'请选择拖车、回厂目的地！'});
		}else{
			this.comp('ddpgContents').to('qxnrCnt');
		}
	}; 
	//抢修内容,【上一步】
	Model.prototype.qxnrPreBtnClick = function(event){
		var qxjg = $(this.getElementsByXid('qxjgSelect')).val();
		if(qxjg === '即修' ){
			this.comp('ddpgContents').to('qxjgCnt');
		}else{
			this.comp('ddpgContents').to('tcddCnt');
		}
	};  
	
	//【已完工】
	Model.prototype.ywgBtnClick = function(event){
		var pageData =this.comp('pageData');
		this.comp('tjskDialog').open({data:{tydd:pageData.val('tydd'),qxnr:pageData.val('qxnr')}});
	};
	Model.prototype.tjskDialogReceive = function(event){
		var saveStr = '';
		var params = new biz.Request.ActionParam();
		params.setString("ygkxpxlh", event.data.chipNum);
		params.setInteger("input_type", this.comp('dispDetailData').val('input_type'));
		params.setInteger("disp_id", this.comp('dispDetailData').val('disp_id'));
		params.setString("qxnr",  $(this.getElementByXid('qxnrText')).val());
		var qxjg = $(this.getElementByXid('qxjgSelect')).val();
		var tydd = '';
		params.setString("qxjg", qxjg);
		if(qxjg !== '即修'){
			tydd = $(this.getElementByXid('tchcSelect')).val();
		}
		params.setString("tydd", tydd);
		params.setInteger("yhpj", event.data.yhpj);
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "taskNormalWgPdaAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					saveStr = resultData.response;
				} else {
					throw new Error('完工处理失败！');
				}
			}
		});

		if (saveStr === '') {
			this.comp('msg').show({message : '完工处理成功！'});
			
			this.comp('pageData').setValue('qxjg','');
			this.comp('pageData').setValue('tydd','');
			this.comp('pageData').setValue('qxnr','');
			
			this.getTaskList();
			this.comp('ddpgContents').to('listCnt');
		} else {
			this.comp('msg').show({message : '完工处理失败！'});
		}
	}; 
	//=======================完工处理 end=============    
	
	//=======================材料清单 begin=============  
	//任务详细页面，点击【材料清单】
	Model.prototype.clqd2BtnClick = function(event){
		clqdSrc = 2;
		this.openClqdWin();
	};
	//抢修内容页面，点击【材料清单】
	Model.prototype.clqdBtnClick = function(event){
		clqdSrc = 1;
		this.openClqdWin();
	};
	Model.prototype.openClqdWin = function(event){
		this.comp('clqdDialog').open({data:{clqdSrc:clqdSrc,taskId:this.comp('dispDetailData').val('task_id'),dispId:this.comp('dispDetailData').val('disp_id')}});
	};
	Model.prototype.clqdDialogReceive = function(event){
    	if(event.data.clqdSrc === 1){
    		this.comp('ddpgContents').to('qxnrCnt');
    		this.setQxnr();
		}else{
    		this.comp('ddpgContents').to('detailCnt');
    		this.setQxnr();
		}
	}; 
	
	//设置抢修内容
	Model.prototype.setQxnr = function(event){
		this.comp('pageData').setValue("qxnr",this.getClqdStr());
	}; 
	Model.prototype.getClqdStr = function(event){
		var clqdStr = "";
		var params = new biz.Request.ActionParam();
		params.setInteger("disp_id", this.comp('dispDetailData').val('disp_id'));
		biz.Request.sendBizRequest({
			"context" : this.getContext(),
			"action" : "getClqdStrAction",
			"parameters" : params,
			"callback" : function(resultData) {
				resultData.ignoreError = false;
				if (resultData.state) {
					clqdStr = resultData.response;
				} else {
					throw new Error('设置抢修内容失败！');
				}
			}
		});
		
		return clqdStr;
	};
	
	//=======================材料清单 end============= 
//	Model.prototype.button1Click = function(event){
////	justep.Shell.showPage(require.toUrl("./shouye.w"));
//		alert(1);
//		justep.Shell.closePage(undefined,false,require.toUrl("$UI/qx/pda/process/shouye/shouye.w"));
//	}; 

//	Model.prototype.modelUnLoad = function(event){
////		this.getParent().shellImpl.showPage("main");
//		 var url = " $UI/qx/pda/process/shouye/shouye.w?process=/qx/pda/process/shouye/shouyeProcess&activity=shouye";
//         this.getParent().openPage({
//             url : url,
//             xid : "main"
//         });
//	}; 
	return Model;
});